## openjph 0.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

project (openjph DESCRIPTION "Open source implementation of JPH" LANGUAGES CXX)

################################################################################################
# Building OpenJPH
################################################################################################

############################################################
# Parse version file
# credit: https://stackoverflow.com/a/47084079

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/src/core/common/ojph_version.h" VERFILE)
if (NOT VERFILE)
    message(FATAL_ERROR "Failed to parse ojph_version.h!")
endif()

string(REGEX MATCH "OPENJPH_VERSION_MAJOR ([0-9])*" _ ${VERFILE})
set(OPENJPH_VERSION_MAJOR ${CMAKE_MATCH_1})
string(REGEX MATCH "OPENJPH_VERSION_MINOR ([0-9])*" _ ${VERFILE})
set(OPENJPH_VERSION_MINOR ${CMAKE_MATCH_1})
string(REGEX MATCH "OPENJPH_VERSION_PATCH ([0-9])*" _ ${VERFILE})
set(OPENJPH_VERSION_PATCH ${CMAKE_MATCH_1})

set(OPENJPH_VERSION "${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}.${OPENJPH_VERSION_PATCH}")
############################################################

option(OJPH_DISABLE_INTEL_SIMD "Disables the use of SIMD instructions and associated files" OFF)
option(BUILD_SHARED_LIBS "Shared Libraries" ON)
option(OJPH_ENABLE_TIFF_SUPPORT "Enables input and output support for TIFF files" ON)
option(OJPH_BUILD_TEST "Enables building test code" OFF)

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()
message(STATUS "Builing ${CMAKE_BUILD_TYPE}")

set(CMAKE_CXX_STANDARD 11)
if (MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /D \"_CRT_SECURE_NO_WARNINGS\"")
endif()
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fexceptions -Wall -Wextra -Wconversion -Wunused-parameter")
endif()

if (OJPH_DISABLE_INTEL_SIMD)
	if (MSVC)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D \"OJPH_DISABLE_INTEL_SIMD\"")
	else()
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DOJPH_DISABLE_INTEL_SIMD")
	endif()
endif()

if (BUILD_SHARED_LIBS AND MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D \"OJPH_BUILD_SHARED_LIBRARY\"")
endif()

if (OJPH_CODE_COVERAGE AND NOT MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
endif()

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/../bin)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/../bin)

include_directories(src/core/common)
include_directories(src/apps/common)

file(GLOB CODESTREAM       "src/core/codestream/*.cpp" "src/core/codestream/*.h")
file(GLOB CODESTREAM_SSE   "src/core/codestream/*_sse.cpp")
file(GLOB CODESTREAM_SSE2  "src/core/codestream/*_sse2.cpp")
file(GLOB CODESTREAM_AVX   "src/core/codestream/*_avx.cpp")
file(GLOB CODESTREAM_AVX2  "src/core/codestream/*_avx2.cpp")
file(GLOB CODESTREAM_WASM  "src/core/codestream/*_wasm.cpp")
file(GLOB CODING           "src/core/coding/*.cpp" "src/core/coding/*.h")
file(GLOB CODING_SSSE3     "src/core/coding/*_ssse3.cpp")
file(GLOB CODING_WASM      "src/core/coding/*_wasm.cpp")
file(GLOB COMMON           "src/core/common/*.h")
file(GLOB OTHERS           "src/core/others/*.cpp")
file(GLOB TRANSFORM        "src/core/transform/*.cpp" "src/core/transform/*.h")
file(GLOB TRANSFORM_SSE    "src/core/transform/*_sse.cpp")
file(GLOB TRANSFORM_SSE2   "src/core/transform/*_sse2.cpp")
file(GLOB TRANSFORM_AVX    "src/core/transform/*_avx.cpp")
file(GLOB TRANSFORM_AVX2   "src/core/transform/*_avx2.cpp")
file(GLOB TRANSFORM_WASM   "src/core/transform/*_wasm.cpp")

list(REMOVE_ITEM CODESTREAM ${CODESTREAM_SSE} ${CODESTREAM_SSE2} ${CODESTREAM_AVX} ${CODESTREAM_AVX2} ${CODESTREAM_WASM})
list(REMOVE_ITEM CODING ${CODING_SSSE3} ${CODING_WASM})
list(REMOVE_ITEM TRANSFORM ${TRANSFORM_SSE} ${TRANSFORM_SSE2} ${TRANSFORM_AVX} ${TRANSFORM_AVX2} ${TRANSFORM_WASM})
list(APPEND SOURCES ${CODESTREAM} ${CODING} ${COMMON} ${OTHERS} ${TRANSFORM})

source_group("codestream"        FILES ${CODESTREAM})
source_group("coding"            FILES ${CODING})
source_group("common"            FILES ${COMMON})
source_group("others"            FILES ${OTHERS})
source_group("transform"         FILES ${TRANSFORM})

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/src/pkg-config.pc.cmake"
  "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${PROJECT_NAME}.pc"
)

if(EMSCRIPTEN)
  set(OJPH_DISABLE_INTEL_SIMD ON)
  set(BUILD_SHARED_LIBS OFF)
  set(OJPH_ENABLE_TIFF_SUPPORT OFF)
  add_compile_options(-std=c++11 -O3 -fexceptions -DOJPH_DISABLE_INTEL_SIMD)
  add_library(openjph ${SOURCES})
  add_library(openjphsimd ${SOURCES} ${CODESTREAM_WASM} ${CODING_WASM} ${TRANSFORM_WASM})
  target_include_directories(openjph PUBLIC src/core/common)
  target_include_directories(openjphsimd PUBLIC src/core/common)
  target_compile_options(openjphsimd PRIVATE -DOJPH_ENABLE_WASM_SIMD -msimd128)
  source_group("codestream" FILES ${CODESTREAM_WASM})
  source_group("coding" FILES ${CODING_WASM})
  source_group("transform" FILES ${TRANSFORM_WASM})
elseif(NOT OJPH_DISABLE_INTEL_SIMD)
  add_library(openjph ${SOURCES} ${CODESTREAM_SSE} ${CODESTREAM_SSE2} ${CODESTREAM_AVX} ${CODESTREAM_AVX2} ${CODING_SSSE3} ${TRANSFORM_SSE} ${TRANSFORM_SSE2} ${TRANSFORM_AVX} ${TRANSFORM_AVX2})
  source_group("codestream" FILES ${CODESTREAM_SSE} ${CODESTREAM_SSE2} ${CODESTREAM_AVX} ${CODESTREAM_AVX2})
  source_group("coding" FILES ${CODING_SSSE3})
  source_group("transform" FILES ${TRANSFORM_SSE} ${TRANSFORM_SSE2} ${TRANSFORM_AVX} ${TRANSFORM_AVX2})
else()
  add_library(openjph ${SOURCES})
endif()

target_include_directories(openjph PUBLIC src/core/common)

target_compile_definitions(openjph PUBLIC _FILE_OFFSET_BITS=64)

if (OPENJPH_VERSION)
  if (WIN32)
    set_target_properties(openjph
      PROPERTIES
        OUTPUT_NAME "openjph.${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}")
  else()
    set_target_properties(openjph
      PROPERTIES
        SOVERSION "${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}"
        VERSION "${OPENJPH_VERSION}")
  endif()
else()
  message(FATAL_ERROR "OPENJPH_VERSION is not set")
endif()

if (MSVC)
  set_source_files_properties(src/core/codestream/ojph_codestream_avx.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX")
  set_source_files_properties(src/core/codestream/ojph_codestream_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
	set_source_files_properties(src/core/transform/ojph_colour_avx.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX")
	set_source_files_properties(src/core/transform/ojph_colour_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
	set_source_files_properties(src/core/transform/ojph_transform_avx.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX")
	set_source_files_properties(src/core/transform/ojph_transform_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
else()
  set_source_files_properties(src/core/codestream/ojph_codestream_avx.cpp PROPERTIES COMPILE_FLAGS -mavx)
  set_source_files_properties(src/core/codestream/ojph_codestream_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
  set_source_files_properties(src/core/coding/ojph_block_decoder_ssse3.cpp PROPERTIES COMPILE_FLAGS -mssse3)
	set_source_files_properties(src/core/transform/ojph_colour_avx.cpp PROPERTIES COMPILE_FLAGS -mavx)
	set_source_files_properties(src/core/transform/ojph_colour_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
	set_source_files_properties(src/core/transform/ojph_transform_avx.cpp PROPERTIES COMPILE_FLAGS -mavx)
	set_source_files_properties(src/core/transform/ojph_transform_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
endif()

############################################################
if( OJPH_ENABLE_TIFF_SUPPORT )

  if( WIN32 )

    set(TIFF_INCLUDE_DIR "C:\\Program Files\\tiff\\include" CACHE PATH "the directory containing the TIFF headers")
    set(TIFF_LIBRARY_DEBUG   "C:\\Program Files\\tiff\\lib\\tiffd.lib" CACHE FILEPATH "the path to the TIFF library for debug configurations")
    set(TIFF_LIBRARY_RELEASE "C:\\Program Files\\tiff\\lib\\tiff.lib"  CACHE FILEPATH "the path to the TIFF library for release configurations")
    set(TIFFXX_LIBRARY_DEBUG  "C:\\Program Files\\tiff\\lib\\tiffxxd.lib" CACHE FILEPATH "the path to the TIFFXX  library for debug configurations")
    set(TIFFXX_LIBRARY_RELEASE "C:\\Program Files\\tiff\\lib\\tiffxx.lib" CACHE FILEPATH "the path to the TIFFXX  library for release configurations")

    message( STATUS "WIN32 detected: Setting CMakeCache TIFF values as follows, use CMake-gui Advanced to modify them" )
    message( STATUS "   TIFF_INCLUDE_DIR : \"${TIFF_INCLUDE_DIR}\"  " )
    message( STATUS "   TIFF_LIBRARY_DEBUG : \"${TIFF_LIBRARY_DEBUG}\"  " )
    message( STATUS "   TIFF_LIBRARY_RELEASE : \"${TIFF_LIBRARY_RELEASE}\"  " )
    message( STATUS "   TIFFXX_LIBRARY_DEBUG : \"${TIFFXX_LIBRARY_DEBUG}\"  " )
    message( STATUS "   TIFFXX_LIBRARY_RELEASE : \"${TIFFXX_LIBRARY_RELEASE}\"  " )

  endif( WIN32 )

  FIND_PACKAGE( TIFF )

  if( TIFF_FOUND )
    set(USE_TIFF TRUE CACHE BOOL "Add TIFF support")
    include_directories( ${TIFF_INCLUDE_DIR} ) 
    if (MSVC)
		  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D \"OJPH_ENABLE_TIFF_SUPPORT\"")
	  else()
		  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DOJPH_ENABLE_TIFF_SUPPORT")
	  endif()
    #include_directories(${CMAKE_BINARY_DIR}/libtiff) # for tiffconf.h on windows
  endif( TIFF_FOUND )

endif() 
############################################################

set(OJPH_EXPAND src/apps/ojph_expand/ojph_expand.cpp src/apps/others/ojph_img_io.cpp)
set(OJPH_COMPRESS src/apps/ojph_compress/ojph_compress.cpp src/apps/others/ojph_img_io.cpp)
set(OJPH_IMG_IO_SSE41 src/apps/others/ojph_img_io_sse41.cpp)
set(OJPH_IMG_IO_AVX2 src/apps/others/ojph_img_io_avx2.cpp)

if(NOT OJPH_DISABLE_INTEL_SIMD)
  list(APPEND OJPH_EXPAND ${OJPH_IMG_IO_SSE41})
  list(APPEND OJPH_EXPAND ${OJPH_IMG_IO_AVX2})
  list(APPEND OJPH_COMPRESS ${OJPH_IMG_IO_SSE41})
  list(APPEND OJPH_COMPRESS ${OJPH_IMG_IO_AVX2})
endif()

add_executable(ojph_expand ${OJPH_EXPAND})
add_executable(ojph_compress ${OJPH_COMPRESS})

if (MSVC)
  set_source_files_properties(src/apps/others/ojph_img_io_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
else()
set_source_files_properties(src/apps/others/ojph_img_io_sse41.cpp PROPERTIES COMPILE_FLAGS -msse4.1)
set_source_files_properties(src/apps/others/ojph_img_io_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
endif()

if( USE_TIFF )
  target_link_libraries(ojph_expand openjph ${TIFF_LIBRARIES})
  target_link_libraries(ojph_compress openjph ${TIFF_LIBRARIES})
else()
  target_link_libraries(ojph_expand openjph)
  target_link_libraries(ojph_compress openjph)
endif()


################################################################################################
# Install
################################################################################################

install(TARGETS ojph_expand
  DESTINATION bin)

install(TARGETS ojph_compress
	DESTINATION bin)

include(GNUInstallDirs)
install(TARGETS openjph LIBRARY
  DESTINATION ${CMAKE_INSTALL_LIBDIR})

install (DIRECTORY src/core/common/
  DESTINATION include/openjph
  FILES_MATCHING
  PATTERN "*.h")

install(FILES "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${PROJECT_NAME}.pc"
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

################################################################################################
# Testing (OJPH_BUILD_TEST)
################################################################################################

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND OJPH_BUILD_TEST)
    include(CTest)
    add_subdirectory(tests)
endif()

=== tests/CMakeLists.txt ===
########################
## Build test exeuctable
########################
project (psnr_pae DESCRIPTION "A program to find PSNR and peak absolute error between two images" LANGUAGES CXX)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(PSNR_PAE psnr_pae.cpp "../src/apps/others/ojph_img_io.cpp" "../src/core/others/ojph_message.cpp" "../src/core/others/ojph_file.cpp" "../src/core/others/ojph_mem.cpp" "../src/core/others/ojph_arch.cpp")
set(OJPH_IMG_IO_SSE41 "../src/apps/others/ojph_img_io_sse41.cpp")
set(OJPH_IMG_IO_AVX2 "../src/apps/others/ojph_img_io_avx2.cpp")

if(NOT OJPH_DISABLE_INTEL_SIMD)
  list(APPEND PSNR_PAE ${OJPH_IMG_IO_SSE41})
  list(APPEND PSNR_PAE ${OJPH_IMG_IO_AVX2})
endif()

add_executable(psnr_pae ${PSNR_PAE})

if (MSVC)
  set_source_files_properties(../src/apps/others/ojph_img_io_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
else()
  set_source_files_properties(../src/apps/others/ojph_img_io_sse41.cpp PROPERTIES COMPILE_FLAGS -msse4.1)
  set_source_files_properties(../src/apps/others/ojph_img_io_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
endif()


IF( USE_TIFF )
  target_link_libraries (psnr_pae ${TIFF_LIBRARIES})
ELSE()
  target_link_libraries (psnr_pae)
ENDIF()

########################
## Test environment
########################
set(ENV{CTEST_OUTPUT_ON_FAILURE} TRUE)
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --verbose)
if (WIN64)
    set(kakadu_name KDU805_Demo_Apps_for_Win64_200602.msi_)
    file(DOWNLOAD https://kakadusoftware.com/wp-content/uploads/${kakadu_name}.zip ./t.zip)
    execute_process(COMMAND unzip -jo ./t.zip ${kakadu_name}/kdu_expand.exe ${kakadu_name}/kdu_compress.exe ${kakadu_name}/kdu_v80R.dll)
endif()
if (UNIX AND NOT APPLE)
    set(kakadu_name KDU805_Demo_Apps_for_Linux-x86-64_200602)
    file(DOWNLOAD https://kakadusoftware.com/wp-content/uploads/${kakadu_name}.zip ./t.zip)
    execute_process(COMMAND unzip -jo ./t.zip ${kakadu_name}/kdu_expand ${kakadu_name}/kdu_compress ${kakadu_name}/libkdu_v80R.so)
endif()
if (APPLE)
message(STATUS "Kakadu tools cannot be extracted automatically on MacOS, because I cannot extract Kakadu from a .dmg file")
message(STATUS "Please make sure that you have kdu_compress, kdu_expand and the respective library in the build folder before running the test.")
#    set(kakadu_name KDU805_Demo_Apps_for_MacOS_200602.dmg_)
#    file(DOWNLOAD https://kakadusoftware.com/wp-content/uploads/${kakadu_name}.zip ./t.zip)
#    execute_process(COMMAND unzip -jo ./t.zip)
#    execute_process(COMMAND unzip -jo ./t.zip ${kakadu_name}/kdu_expand ${kakadu_name}/kdu_compress ${kakadu_name}/libkdu_v80R.so)
endif()


set(images_folder ..)
if (NOT EXISTS "./im1.ppm")
    file(DOWNLOAD https://github.com/aous72/aous72.github.io/raw/master/test_images/Malamute.ppm ./im1.ppm)
endif()
if (NOT EXISTS "./im2.ppm")
    file(DOWNLOAD https://github.com/aous72/aous72.github.io/raw/master/test_images/Rainier.ppm ./im2.ppm)
endif()
if (NOT EXISTS "./im3.ppm")
    file(DOWNLOAD https://github.com/aous72/aous72.github.io/raw/master/test_images/monarch.ppm ./im3.ppm)
endif()
if (NOT EXISTS "./im3.pgm")
    file(DOWNLOAD https://github.com/aous72/aous72.github.io/raw/master/test_images/monarch.pgm ./im3.pgm)
endif()
if (NOT EXISTS "./mm.ppm")
    file(DOWNLOAD https://github.com/aous72/aous72.github.io/raw/master/test_images/mm.ppm ./mm.ppm)
endif()
if (NOT EXISTS "./mm.pgm")
    file(DOWNLOAD https://github.com/aous72/aous72.github.io/raw/master/test_images/mm.pgm ./mm.pgm)
endif()
if (NOT EXISTS "./tall_narrow.ppm")
    file(DOWNLOAD https://github.com/aous72/aous72.github.io/raw/master/test_images/tall_narrow.ppm ./tall_narrow.ppm)
endif()
if (NOT EXISTS "./lena_444.yuv")
    file(DOWNLOAD https://github.com/aous72/aous72.github.io/raw/master/test_images/lena_444.yuv ./lena_444.yuv)
    execute_process(COMMAND dd if=lena_444.yuv of=lena_444y.rawl bs=1 count=262144)
    execute_process(COMMAND dd if=lena_444.yuv of=lena_444u.rawl bs=1 count=262144 skip=262144)
    execute_process(COMMAND dd if=lena_444.yuv of=lena_444v.rawl bs=1 count=262144 skip=524288)
endif()
if (NOT EXISTS "./foreman_422.yuv")
    file(DOWNLOAD https://github.com/aous72/aous72.github.io/raw/master/test_images/foreman_422.yuv ./foreman_422.yuv)
    execute_process(COMMAND dd if=foreman_422.yuv of=foreman_422y.rawl bs=1 count=101376)
    execute_process(COMMAND dd if=foreman_422.yuv of=foreman_422u.rawl bs=1 count=50688 skip=101376)
    execute_process(COMMAND dd if=foreman_422.yuv of=foreman_422v.rawl bs=1 count=50688 skip=152064)
endif()
if (NOT EXISTS "./foreman_420.yuv")
    file(DOWNLOAD https://github.com/aous72/aous72.github.io/raw/master/test_images/foreman_420.yuv ./foreman_420.yuv)
    execute_process(COMMAND dd if=foreman_420.yuv of=foreman_420y.rawl bs=1 count=101376)
    execute_process(COMMAND dd if=foreman_420.yuv of=foreman_420u.rawl bs=1 count=25344 skip=101376)
    execute_process(COMMAND dd if=foreman_420.yuv of=foreman_420v.rawl bs=1 count=25344 skip=126720)
endif()

add_test(NAME no_argument_ojph_compress COMMAND ojph_compress)
set_tests_properties(no_argument_ojph_compress PROPERTIES WILL_FAIL TRUE)

#############################################################
# Decoding
#############################################################

add_test(NAME simple_dec_irv97_64x64 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 0.5"  "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_irv97_32x32 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 1 Cblk=\{32,32\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_irv97_16x16 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 1 Cblk=\{16,16\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_irv97_4x4 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 1 Cblk=\{4,4\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_irv97_1024x4 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 1 Cblk=\{1024,4\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_irv97_4x1024 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 1 Cblk=\{4,1024\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_irv97_512x8 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 1 Cblk=\{512,8\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_irv97_8x512 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 1 Cblk=\{8,512\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_irv97_256x16 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 1 Cblk=\{256,16\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_irv97_16x256 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 1 Cblk=\{16,256\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_irv97_128x32 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 1 Cblk=\{128,32\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_irv97_32x128 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -dec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet -rate 1 Cblk=\{32,128\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")

add_test(NAME simple_dec_rev53_64x64 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -rdec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet Creversible=yes"  "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_rev53_32x32 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -rdec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet Creversible=yes Cblk=\{32,32\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_rev53_4x4 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -rdec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet Creversible=yes Cblk=\{4,4\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_rev53_1024x4 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -rdec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet Creversible=yes Cblk=\{1024,4\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")
add_test(NAME simple_dec_rev53_4x1024 COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom.sh -rdec "-i ${images_folder}/im1.ppm -o test.jph -precise -quiet Creversible=yes Cblk=\{4,1024\}" "-i test.jph -o test1.ppm -precise -quiet" "-i test.jph -o test2.ppm" "${images_folder}/im1.ppm" "test1.ppm" "test2.ppm")

add_test(NAME simple_dec_irv97_64x64_yuv COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom_yuv.sh -dec "-i ${images_folder}/foreman_420y.rawl,${images_folder}/foreman_420u.rawl,${images_folder}/foreman_420v.rawl -o test.jph -precise -quiet -rate 0.5 Sdims=\{288,352\},\{144,176\},\{144,176\} Ssampling=\{1,1\},\{2,2\},\{2,2\} Nprecision=\{8\} Nsigned=\{no\}"  "-i test.jph -o test1y.rawl,test1u.rawl,test1v.rawl -precise -quiet" "-i test.jph -o test2.yuv" "${images_folder}/foreman_420.yuv:352x288x8x420" "test1.yuv:352x288x8x420" "test2.yuv:352x288x8x420")
add_test(NAME simple_dec_rev53_64x64_yuv COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/com_decom_yuv.sh -rdec "-i ${images_folder}/foreman_420y.rawl,${images_folder}/foreman_420u.rawl,${images_folder}/foreman_420v.rawl -o test.jph -precise -quiet Creversible=yes Sdims=\{288,352\},\{144,176\},\{144,176\} Ssampling=\{1,1\},\{2,2\},\{2,2\} Nprecision=\{8\} Nsigned=\{no\}"  "-i test.jph -o test1y.rawl,test1u.rawl,test1v.rawl -precise -quiet" "-i test.jph -o test2.yuv" "${images_folder}/foreman_420.yuv:352x288x8x420" "test1.yuv:352x288x8x420" "test2.yuv:352x288x8x420")

=== subprojects/js/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

set(CMAKE_SYSTEM_NAME Generic)

project (openjphwasm DESCRIPTION "Open source implementation of JPH" LANGUAGES CXX)

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/../html)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/../html)

add_subdirectory("../.." openjph EXCLUDE_FROM_ALL)
add_executable(libopenjph "src/ojph_wrapper.cpp")
set_target_properties(libopenjph PROPERTIES SUFFIX ".js" LINK_FLAGS "-O3 -s WASM=1 -s EXPORT_ES6=1 -s MODULARIZE=1 -s ENVIRONMENT=web -s EXPORTED_FUNCTIONS=[_free,_malloc] -s EXPORTED_RUNTIME_METHODS=[ccall,cwrap,writeArrayToMemory] -s NO_EXIT_RUNTIME=1 -s ALLOW_MEMORY_GROWTH=1")
target_link_libraries(libopenjph PRIVATE openjph)

add_executable(libopenjph_simd "src/ojph_wrapper.cpp" )
target_compile_options(libopenjph_simd PRIVATE -DOJPH_ENABLE_WASM_SIMD -msimd128)
set_target_properties(libopenjph_simd PROPERTIES SUFFIX ".js" LINK_FLAGS "-O3 -s WASM=1 -s EXPORT_ES6=1 -s MODULARIZE=1 -s ENVIRONMENT=web -s EXPORTED_FUNCTIONS=[_free,_malloc] -s EXPORTED_RUNTIME_METHODS=[ccall,cwrap,writeArrayToMemory] -s NO_EXIT_RUNTIME=1 -s ALLOW_MEMORY_GROWTH=1")
target_link_libraries(libopenjph_simd PRIVATE openjphsimd)

=== debian/changelog ===
openjph (0.9.0-3) unstable; urgency=medium

  * d/copyright Make sure to also remove simd version
  * d/symbols: Remove extra debug symbols

 -- Mathieu Malaterre <malat@debian.org>  Thu, 23 Jun 2022 10:22:24 +0200

openjph (0.9.0-2) unstable; urgency=medium

  * d/control: Bump Std-Vers to 4.6.1 no changes needed

 -- Mathieu Malaterre <malat@debian.org>  Thu, 23 Jun 2022 08:48:59 +0200

openjph (0.9.0-1) unstable; urgency=medium

  * New upstream version 0.9.0
  * d/patches: Remove patches applied upstream
  * d/control: Bump to new SONAME 0.9
  * d/symbols: Add missing symbols

 -- Mathieu Malaterre <malat@debian.org>  Mon, 20 Jun 2022 17:28:40 +0200

openjph (0.8.2-5) unstable; urgency=medium

  * d/patches: Really fix file/64bits issue on 32bits arch

 -- Mathieu Malaterre <malat@debian.org>  Wed, 30 Mar 2022 10:00:21 +0200

openjph (0.8.2-4) unstable; urgency=medium

  * d/rules: Add explanation for missing test suite
  * d/patches: Remove bogus symbol patch
  * d/patches: Make sure to handle kFreeBSD also
  * d/patches: Make sure to use 64bits file API

 -- Mathieu Malaterre <malat@debian.org>  Mon, 14 Mar 2022 12:20:49 +0100

openjph (0.8.2-3) unstable; urgency=medium

  * d/rules: Make sure to clean generated manpages
  * d/control: Add missing help2man/doxygen dependencies

 -- Mathieu Malaterre <malat@debian.org>  Sat, 12 Mar 2022 18:04:40 +0100

openjph (0.8.2-2) unstable; urgency=medium

  * Upload to unstable
  * d/rules: Fix compilation on non-amd64 arch
  * d/symbols: Add missing symbols file
  * d/manpages: Fix typo in man pages
  * d/symbols: Remove all but amd64 symbols files
  * d/rules: Prefer ninja build system over make
  * d/control: Reduce cmake version dependency
  * d/rules: Remove test suite for now

 -- Mathieu Malaterre <malat@debian.org>  Sat, 12 Mar 2022 17:01:33 +0100

openjph (0.8.2-1) experimental; urgency=medium

  * Initial release (Closes: #1006929)

 -- Mathieu Malaterre <malat@debian.org>  Tue, 08 Mar 2022 12:54:54 +0100

=== debian/control ===
Source: openjph
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: cmake (>= 3.10),
               debhelper (>= 11),
               help2man,
               libtiff-dev,
               ninja-build
Build-Depends-Indep: doxygen
Standards-Version: 4.6.1
Homepage: https://github.com/aous72/OpenJPH
Vcs-Git: https://salsa.debian.org/debian-phototools-team/openjph.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjph
Rules-Requires-Root: no

Package: libopenjph0.9
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: HTJ2K image compression/decompression library (runtime files)
 Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000
 Part 15, ISO/IEC 15444-15, and ITU-T T.814. This library only implements HTJ2K
 only, supporting features that are defined in JPEG2000 Part 1 (for example, for
 wavelet transform, only reversible 5/3 and irreversible 9/7 are supported).
 .
 This package installs the runtime files.

Package: libopenjph-dev
Architecture: any
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libopenjph0.9 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: HTJ2K image compression/decompression library (developer files)
 Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000
 Part 15, ISO/IEC 15444-15, and ITU-T T.814. This library only implements HTJ2K
 only, supporting features that are defined in JPEG2000 Part 1 (for example, for
 wavelet transform, only reversible 5/3 and irreversible 9/7 are supported).
 .
 This package installs the development files.

Package: openjph-tools
Architecture: any
Section: graphics
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: HTJ2K image compression/decompression library (command line tools)
 Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000
 Part 15, ISO/IEC 15444-15, and ITU-T T.814. This library only implements HTJ2K
 only, supporting features that are defined in JPEG2000 Part 1 (for example, for
 wavelet transform, only reversible 5/3 and irreversible 9/7 are supported).
 .
 This package installs the command line utilities.

Package: openjph-doc
Architecture: all
Section: doc
Depends: doc-base, ${misc:Depends}
Description: HTJ2K image compression/decompression library (documentation files)
 Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000
 Part 15, ISO/IEC 15444-15, and ITU-T T.814. This library only implements HTJ2K
 only, supporting features that are defined in JPEG2000 Part 1 (for example, for
 wavelet transform, only reversible 5/3 and irreversible 9/7 are supported).
 .
 This package installs the documentation files.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

%:
	dh $@ --buildsystem=cmake+ninja

ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),amd64 x32))
  CMAKE_EXTRA_FLAGS += -DOJPH_DISABLE_INTEL_SIMD:BOOL=OFF
else
  CMAKE_EXTRA_FLAGS += -DOJPH_DISABLE_INTEL_SIMD:BOOL=ON
endif

# upstream requires amd64 binaries from kakadu (non-free) to run non-regression
# testing. Make sure to set BUILD_TESTING to OFF for now:
ifeq (,$(filter check,$(OPENJPH_BUILD_TESTING)))
  BUILD_TESTING=OFF
else
  BUILD_TESTING=ON
endif

CMAKE_EXTRA_FLAGS += \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING:BOOL=$(BUILD_TESTING) \

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_build-indep:
	(cd docs && doxygen)

override_dh_auto_install-indep:

override_dh_auto_test-indep:

override_dh_clean-indep:
	dh_clean docs/html/

override_dh_installdocs-arch: manpages
	dh_installdocs

override_dh_auto_test-arch:
ifeq (,$(filter check,$(OPENJPH_BUILD_TESTING)))
else
	dh_auto_test
endif

override_dh_clean-arch:
	dh_clean bin/ojph_compress
	dh_clean bin/ojph_expand
	dh_clean bin/openjph.pc
	dh_clean bin/libopenjph.*
	dh_clean debian/*.1

debian/ojph_compress.1: debian/ojph_compress.1.in
	LD_PRELOAD= LD_LIBRARY_PATH=./debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) help2man --version-string=$(DEB_VERSION_UPSTREAM) --help-option=" " --include=$< --output=$@ --no-info --no-discard-stderr ./debian/tmp/usr/bin/ojph_compress

debian/ojph_expand.1: debian/ojph_expand.1.in
	LD_PRELOAD= LD_LIBRARY_PATH=./debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) help2man --version-string=$(DEB_VERSION_UPSTREAM) --help-option=" " --include=$< --output=$@ --no-info --no-discard-stderr ./debian/tmp/usr/bin/ojph_expand

.PHONY: manpages

manpages: debian/ojph_compress.1 debian/ojph_expand.1

## openjph 0.18.2

=== debian/changelog ===
openjph (0.18.2-2) unstable; urgency=medium

  * Team upload.
  * new upstream not use OPENJPH_BUILD_TESTING env variable
    - d/rules: don't set BUILD_TESTING env variable
    - d/rules: remove override_dh_auto_test-arch target
    - d/rules: CMAKE_EXTRA_FLAGS remove -DBUILD_TESTING:BOOL= line
    - delete d/README.Debian
  * d/rules: use OJPH_DISABLE_SIMD instead of deprecated OJPH_DISABLE_INTEL_SIMD
  * d/copyright:
      - change License from BSD-2 to BSD-2-clause, let lrc happy
      - update-debian-copyright year info to 2025

 -- xiao sheng wen <atzlinux@debian.org>  Wed, 01 Jan 2025 10:23:27 +0800

openjph (0.18.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No change source-only upload.

 -- Boyuan Yang <byang@debian.org>  Tue, 31 Dec 2024 13:35:20 -0500

openjph (0.18.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * d/openjph-doc.docs: use docs/* to install whole docs directory
  * Bump to new SONAME 0.18
  * d/rules: DEB_BUILD_MAINT_OPTIONS add optimize=+lto, Closes: #1015566
  * delete old d/libopenjph0.10.symbols

 -- xiao sheng wen <atzlinux@debian.org>  Tue, 17 Dec 2024 09:12:05 +0800

openjph (0.10.3-2) unstable; urgency=medium

  * Team upload.
  * d/control: remove Build-Depends-Indep field, add doxygen to Build-Depends

 -- xiao sheng wen <atzlinux@debian.org>  Thu, 12 Dec 2024 16:09:42 +0800

openjph (0.10.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Add salsa-ci file (routine-update)
  * d/control:
      - Build-Depends: delete ninja-build
      - binary package libopenjph0.9 rename to libopenjph0.10
  * rm d/libopenjph0.9.install d/libopenjph0.9.symbols.amd64
  * add d/libopenjph0.10.install
  * add d/libopenjph0.10.symbols
  * add d/clean
  * d/rules:
      - remove override_dh_clean-arch override_dh_clean-indep target
      - use execute_after_dh_auto_build target
      - use execute_before_dh_installman target
      - use "dh $@" only, remove "--buildsystem=cmake+ninja"
  * d/copyright:
      - update year info to 2024
      - delete Files-Excluded field, useless
      - add Upstream-Contact: Aous Naman <aous@unsw.edu.au>

 -- xiao sheng wen <atzlinux@sina.com>  Tue, 30 Jan 2024 17:27:05 +0800

=== debian/control ===
--- 
+++ 
@@ -3,19 +3,18 @@
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
-Build-Depends: cmake (>= 3.10),
-               debhelper (>= 11),
+Build-Depends: cmake,
+               debhelper-compat (= 13),
                help2man,
                libtiff-dev,
-               ninja-build
-Build-Depends-Indep: doxygen
-Standards-Version: 4.6.1
+               doxygen,
+Standards-Version: 4.7.0
 Homepage: https://github.com/aous72/OpenJPH
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/openjph.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjph
 Rules-Requires-Root: no
 
-Package: libopenjph0.9
+Package: libopenjph0.18
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -32,7 +31,7 @@
 Architecture: any
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libopenjph0.9 (= ${binary:Version}), ${misc:Depends}
+Depends: libopenjph0.18 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: HTJ2K image compression/decompression library (developer files)
  Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000

## openjph 0.21.0

=== src/core/CMakeLists.txt ===

file(GLOB CODESTREAM       "codestream/*.cpp" "codestream/*.h")
file(GLOB CODESTREAM_SSE   "codestream/*_sse.cpp")
file(GLOB CODESTREAM_SSE2  "codestream/*_sse2.cpp")
file(GLOB CODESTREAM_AVX   "codestream/*_avx.cpp")
file(GLOB CODESTREAM_AVX2  "codestream/*_avx2.cpp")
file(GLOB CODESTREAM_WASM  "codestream/*_wasm.cpp")
file(GLOB CODING           "coding/*.cpp" "coding/*.h")
file(GLOB CODING_SSSE3     "coding/*_ssse3.cpp")
file(GLOB CODING_WASM      "coding/*_wasm.cpp")
file(GLOB CODING_AVX2      "coding/*_avx2.cpp")
file(GLOB CODING_AVX512    "coding/*_avx512.cpp")
file(GLOB COMMON           "common/*.h")
file(GLOB OTHERS           "others/*.cpp")
file(GLOB TRANSFORM        "transform/*.cpp" "transform/*.h")
file(GLOB TRANSFORM_SSE    "transform/*_sse.cpp")
file(GLOB TRANSFORM_SSE2   "transform/*_sse2.cpp")
file(GLOB TRANSFORM_AVX    "transform/*_avx.cpp")
file(GLOB TRANSFORM_AVX2   "transform/*_avx2.cpp")
file(GLOB TRANSFORM_AVX512 "transform/*_avx512.cpp")
file(GLOB TRANSFORM_WASM   "transform/*_wasm.cpp")

list(REMOVE_ITEM CODESTREAM ${CODESTREAM_SSE} ${CODESTREAM_SSE2} ${CODESTREAM_AVX} ${CODESTREAM_AVX2} ${CODESTREAM_WASM})
list(REMOVE_ITEM CODING ${CODING_SSSE3} ${CODING_WASM} ${CODING_AVX2} ${CODING_AVX512})
list(REMOVE_ITEM TRANSFORM ${TRANSFORM_SSE} ${TRANSFORM_SSE2} ${TRANSFORM_AVX} ${TRANSFORM_AVX2} ${TRANSFORM_AVX512} ${TRANSFORM_WASM})
list(APPEND SOURCES ${CODESTREAM} ${CODING} ${COMMON} ${OTHERS} ${TRANSFORM})

source_group("codestream"        FILES ${CODESTREAM})
source_group("coding"            FILES ${CODING})
source_group("common"            FILES ${COMMON})
source_group("others"            FILES ${OTHERS})
source_group("transform"         FILES ${TRANSFORM})

if(EMSCRIPTEN)
  if (OJPH_ENABLE_WASM_SIMD)
    list(APPEND SOURCES ${CODESTREAM_WASM} ${CODING_WASM} ${TRANSFORM_WASM})
    source_group("codestream" FILES ${CODESTREAM_WASM})
    source_group("coding" FILES ${CODING_WASM})
    source_group("transform" FILES ${TRANSFORM_WASM})
  endif()
else()
  if (NOT OJPH_DISABLE_SIMD)
    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64") OR ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_I386"))

      if (NOT OJPH_DISABLE_SSE)
        list(APPEND SOURCES ${CODESTREAM_SSE} ${TRANSFORM_SSE})
        source_group("codestream" FILES ${CODESTREAM_SSE})
        source_group("transform" FILES ${TRANSFORM_SSE})
      endif()
      if (NOT OJPH_DISABLE_SSE2)
        list(APPEND SOURCES ${CODESTREAM_SSE2} ${TRANSFORM_SSE2})
        source_group("codestream" FILES ${CODESTREAM_SSE2})
        source_group("transform" FILES ${TRANSFORM_SSE2})
      endif()
      if (NOT OJPH_DISABLE_SSSE3)
        list(APPEND SOURCES ${CODING_SSSE3})
        source_group("coding" FILES ${CODING_SSSE3})
      endif()
      if (NOT OJPH_DISABLE_AVX)
        list(APPEND SOURCES ${CODESTREAM_AVX} ${TRANSFORM_AVX})
        source_group("codestream" FILES ${CODESTREAM_AVX})
        source_group("transform" FILES ${TRANSFORM_AVX})
      endif()
      if (NOT OJPH_DISABLE_AVX2)
        list(APPEND SOURCES ${CODESTREAM_AVX2} ${TRANSFORM_AVX2} ${CODING_AVX2})
        source_group("codestream" FILES ${CODESTREAM_AVX2})
        source_group("transform" FILES ${TRANSFORM_AVX2})
        source_group("coding" FILES ${CODING_AVX2})
      endif()
      if ((NOT OJPH_DISABLE_AVX512) AND ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64"))
        list(APPEND SOURCES ${CODING_AVX512} ${TRANSFORM_AVX512})
        source_group("coding" FILES ${CODING_AVX512})
        source_group("transform" FILES ${TRANSFORM_AVX512})
      endif()

      # Set compilation flags
      if (MSVC)
        set_source_files_properties(codestream/ojph_codestream_avx.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX")
        set_source_files_properties(codestream/ojph_codestream_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
        set_source_files_properties(coding/ojph_block_decoder_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
        set_source_files_properties(coding/ojph_block_encoder_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
        set_source_files_properties(coding/ojph_block_encoder_avx512.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX512")
        set_source_files_properties(transform/ojph_colour_avx.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX")
        set_source_files_properties(transform/ojph_colour_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
        set_source_files_properties(transform/ojph_transform_avx.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX")
        set_source_files_properties(transform/ojph_transform_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
        set_source_files_properties(transform/ojph_transform_avx512.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX512")
      else()
        set_source_files_properties(codestream/ojph_codestream_avx.cpp PROPERTIES COMPILE_FLAGS -mavx)
        set_source_files_properties(codestream/ojph_codestream_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
        set_source_files_properties(coding/ojph_block_decoder_ssse3.cpp PROPERTIES COMPILE_FLAGS -mssse3)
        set_source_files_properties(coding/ojph_block_decoder_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
        set_source_files_properties(coding/ojph_block_encoder_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
        set_source_files_properties(coding/ojph_block_encoder_avx512.cpp PROPERTIES COMPILE_FLAGS -mavx512cd)
        set_source_files_properties(transform/ojph_colour_avx.cpp PROPERTIES COMPILE_FLAGS -mavx)
        set_source_files_properties(transform/ojph_colour_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
        set_source_files_properties(transform/ojph_transform_avx.cpp PROPERTIES COMPILE_FLAGS -mavx)
        set_source_files_properties(transform/ojph_transform_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
        set_source_files_properties(transform/ojph_transform_avx512.cpp PROPERTIES COMPILE_FLAGS -mavx512f)
      endif()

    elseif ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_ARM")

    endif()

  endif()


endif()

add_library(openjph ${SOURCES})

## The option BUILD_SHARED_LIBS
if (BUILD_SHARED_LIBS AND WIN32)
  target_compile_definitions(openjph PRIVATE OJPH_BUILD_SHARED_LIBRARY)
endif()

## include library version/name
target_compile_definitions(openjph PUBLIC _FILE_OFFSET_BITS=64)
target_include_directories(openjph PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/common> $<INSTALL_INTERFACE:include/openjph>)

if (MSVC)
  set(OJPH_LIB_NAME_STRING "openjph.${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}")
  set_target_properties(openjph
    PROPERTIES
      OUTPUT_NAME "openjph.${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}")
else()
  set(OJPH_LIB_NAME_STRING "openjph.${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}")
  set_target_properties(openjph
    PROPERTIES
      SOVERSION "${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}"
      VERSION "${OPENJPH_VERSION}")
endif()

install(TARGETS openjph
  EXPORT openjph-config
)

install(DIRECTORY common/
  DESTINATION include/openjph
  FILES_MATCHING
  PATTERN "*.h"
)

=== src/apps/ojph_compress/CMakeLists.txt ===
## building ojph_compress
#########################

file(GLOB OJPH_COMPRESS       "ojph_compress.cpp")
file(GLOB OJPH_IMG_IO         "../others/ojph_img_io.cpp")
file(GLOB OJPH_IMG_IO_SSE4    "../others/ojph_img_io_sse41.cpp")
file(GLOB OJPH_IMG_IO_AVX2    "../others/ojph_img_io_avx2.cpp")
file(GLOB OJPH_IMG_IO_H       "../common/ojph_img_io.h")

list(APPEND SOURCES ${OJPH_COMPRESS} ${OJPH_IMG_IO} ${OJPH_IMG_IO_H})

source_group("main"        FILES ${OJPH_COMPRESS})
source_group("others"      FILES ${OJPH_IMG_IO})
source_group("common"      FILES ${OJPH_IMG_IO_H})

if(EMSCRIPTEN)
  if (OJPH_ENABLE_WASM_SIMD)
    list(APPEND SOURCES ${OJPH_IMG_IO_SSE4})
    source_group("others" FILES ${OJPH_IMG_IO_SSE4})
    set_source_files_properties(${OJPH_IMG_IO_SSE4} PROPERTIES COMPILE_FLAGS -msse4.1)
  endif()
else()
  if (NOT OJPH_DISABLE_SIMD)
    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64") OR ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_I386"))
      if (NOT OJPH_DISABLE_SSE4)
        list(APPEND SOURCES ${OJPH_IMG_IO_SSE4})
        source_group("others" FILES ${OJPH_IMG_IO_SSE4})
      endif()
      if (NOT OJPH_DISABLE_AVX2)
        list(APPEND SOURCES ${OJPH_IMG_IO_AVX2})
        source_group("others" FILES ${OJPH_IMG_IO_AVX2})
      endif()

      # Set compilation flags
      if (MSVC)
        set_source_files_properties(${OJPH_IMG_IO_AVX2} PROPERTIES COMPILE_FLAGS "/arch:AVX2")
      else()
        set_source_files_properties(${OJPH_IMG_IO_SSE4} PROPERTIES COMPILE_FLAGS -msse4.1)
        set_source_files_properties(${OJPH_IMG_IO_AVX2} PROPERTIES COMPILE_FLAGS -mavx2)
      endif()
    elseif ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_ARM")

    endif()

  endif()

endif()

add_executable(ojph_compress ${SOURCES})
target_include_directories(ojph_compress PRIVATE ../common)
target_link_libraries(ojph_compress PRIVATE openjph $<TARGET_NAME_IF_EXISTS:TIFF::TIFF>)

install(TARGETS ojph_compress
  EXPORT openjph-config
)

=== src/apps/ojph_expand/CMakeLists.txt ===
## building ojph_expand
#######################

file(GLOB OJPH_EXPAND         "ojph_expand.cpp")
file(GLOB OJPH_IMG_IO         "../others/ojph_img_io.cpp")
file(GLOB OJPH_IMG_IO_SSE4    "../others/ojph_img_io_sse41.cpp")
file(GLOB OJPH_IMG_IO_AVX2    "../others/ojph_img_io_avx2.cpp")
file(GLOB OJPH_IMG_IO_H       "../common/ojph_img_io.h")

list(APPEND SOURCES ${OJPH_EXPAND} ${OJPH_IMG_IO} ${OJPH_IMG_IO_H})

source_group("main"        FILES ${OJPH_EXPAND})
source_group("others"      FILES ${OJPH_IMG_IO})
source_group("common"      FILES ${OJPH_IMG_IO_H})

if(EMSCRIPTEN)
  if (OJPH_ENABLE_WASM_SIMD)
    list(APPEND SOURCES ${OJPH_IMG_IO_SSE4})
    source_group("others" FILES ${OJPH_IMG_IO_SSE4})
    set_source_files_properties(${OJPH_IMG_IO_SSE4} PROPERTIES COMPILE_FLAGS -msse4.1)
  endif()
else()
  if (NOT OJPH_DISABLE_SIMD)
    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64") OR ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_I386"))
      if (NOT OJPH_DISABLE_SSE4)
        list(APPEND SOURCES ${OJPH_IMG_IO_SSE4})
        source_group("others" FILES ${OJPH_IMG_IO_SSE4})
      endif()
      if (NOT OJPH_DISABLE_AVX2)
        list(APPEND SOURCES ${OJPH_IMG_IO_AVX2})
        source_group("others" FILES ${OJPH_IMG_IO_AVX2})
      endif()

      # Set compilation flags
      if (MSVC)
        set_source_files_properties(${OJPH_IMG_IO_AVX2} PROPERTIES COMPILE_FLAGS "/arch:AVX2")
      else()
        set_source_files_properties(${OJPH_IMG_IO_SSE4} PROPERTIES COMPILE_FLAGS -msse4.1)
        set_source_files_properties(${OJPH_IMG_IO_AVX2} PROPERTIES COMPILE_FLAGS -mavx2)
      endif()
    elseif ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_ARM")

    endif()

  endif()

endif()

add_executable(ojph_expand ${SOURCES})
target_include_directories(ojph_expand PRIVATE ../common)
target_link_libraries(ojph_expand PRIVATE openjph $<TARGET_NAME_IF_EXISTS:TIFF::TIFF>)

install(TARGETS ojph_expand
  EXPORT openjph-config
)

=== src/apps/ojph_stream_expand/CMakeLists.txt ===
## building ojph_stream_expand
##############################

set(CMAKE_CXX_STANDARD 14)

file(GLOB OJPH_STREAM_EXPAND  "*.cpp" "*.h")
file(GLOB OJPH_SOCKETS         "../others/ojph_sockets.cpp")
file(GLOB OJPH_SOCKETS_H       "../common/ojph_sockets.h")
file(GLOB OJPH_THREADS        "../others/ojph_threads.cpp")
file(GLOB OJPH_THREADS_H      "../common/ojph_threads.h")

list(APPEND SOURCES ${OJPH_STREAM_EXPAND} ${OJPH_SOCKETS} ${OJPH_SOCKETS_H} ${OJPH_THREADS} ${OJPH_THREADS_H})

source_group("main"        FILES ${OJPH_STREAM_EXPAND})
source_group("others"      FILES ${OJPH_SOCKETS} ${OJPH_THREADS})
source_group("common"      FILES ${OJPH_SOCKETS_H} ${OJPH_THREADS_H})

add_executable(ojph_stream_expand ${SOURCES})
target_include_directories(ojph_stream_expand PRIVATE ../common)
if(MSVC)
    target_link_libraries(ojph_stream_expand PUBLIC openjph ws2_32)
else()
    target_link_libraries(ojph_stream_expand PUBLIC openjph pthread)
endif(MSVC)

install(TARGETS ojph_stream_expand
  EXPORT openjph-config
)

=== debian/changelog ===
openjph (0.21.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No change source-only upload.

 -- Boyuan Yang <byang@debian.org>  Sun, 16 Feb 2025 16:46:02 -0500

openjph (0.21.0-1) unstable; urgency=medium

  * New upstream version 0.21.0
  * d/control: Bump SOVERSION to to 0.21
  * d/install: Install missing cmake files

 -- Mathieu Malaterre <malat@debian.org>  Thu, 06 Feb 2025 08:36:49 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjph
 Rules-Requires-Root: no
 
-Package: libopenjph0.18
+Package: libopenjph0.21
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -31,7 +31,7 @@
 Architecture: any
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libopenjph0.18 (= ${binary:Version}), ${misc:Depends}
+Depends: libopenjph0.21 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: HTJ2K image compression/decompression library (developer files)
  Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000
